/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 32 "./mips_y.y"

#include <stdio.h>
#include "mut.h"
#include "log.h"
#include "beh.h"
#include "mips_type.h"
#include "mips_defs.h"
#include "mips_yacc.h"

main (argc, argv)

int   argc   ;
char *argv [];

  {
  extern FILE  *yyin          ;
  extern FILE  *MPS_WRTFIL    ;
  extern FILE  *MPS_TXTFIL    ;
  extern FILE  *MPS_DATFIL    ;
  extern FILE  *MPS_SYMFIL    ;
  FILE         *fp_read       ;
  char          arg_flg [ 32] ;
  unsigned int  txt_siz       = 256;
  unsigned int  dat_siz       =  64;
  int           exit_val      =   1;
  int           asm_fil       =   0;
  int           txt_fil       =   0;
  int           dat_fil       =   0;
  int           i             ;
  char         *symbol_fil    ;
  char          arg_err       =   0;
  static int    call_nbr      =   0;

	/* ###------------------------------------------------------### */
	/*   initializations						*/
	/* ###------------------------------------------------------### */

  mbkenv ();

  alliancebanner_with_authors( "asm", "v0.3",
                  "MIPS Assembler", "1992",
                  ALLIANCE_VERSION,
                  "Pirouz Bazargan Sabet" );

  for (i=1 ; i<argc ; i++)
    arg_flg [i] = 0;

  if (MPS_HSHTAB == NULL)
    MPS_HSHTAB = beh_initab ();

	/* ###------------------------------------------------------### */
	/*   analyze the command line:					*/
	/*     - for each argument set a flag to 1 if recognized	*/
	/*     - find the last recognized option to identify the source	*/
	/*       and result files					*/
	/* ###------------------------------------------------------### */

  arg_flg [0] = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      {
      if (!strcmp (argv[i], "-textsize"))
        {
        sscanf (argv[i+1], "%u", &txt_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-datasize"))
        {
        sscanf (argv[i+1], "%u", &dat_siz);
        arg_flg [i  ] = 1;
        arg_flg [i+1] = 1;
        }

      if (!strcmp (argv[i], "-dump"))
        {
        MPS_DUMP      = 'y'       ;
        arg_flg [i]   = 1         ;
        }

      if (!strcmp (argv[i], "-symbol"))
        {
        MPS_SYMBOL    = 'y'       ;
        symbol_fil    = argv [i+1];
        arg_flg [i]   = 1         ;
        arg_flg [i+1] = 1         ;
        }

      }
    }

  for (i=(argc-1) ; i>0 ; i--)
    {
    if (arg_flg [i] == 1)
      break;
    }

  asm_fil       = i + 1;
  arg_flg [i+1] = 1    ;
  txt_fil       = i + 2;
  arg_flg [i+2] = 1    ;

  if ((i+3) < argc)
    {
    dat_fil       = i + 3;
    arg_flg [i+3] = 1    ;
    }


	/* ###------------------------------------------------------### */
	/*   cases of errors on the command line:			*/
	/*     - a unrecognized argument				*/
	/*     - not enough arguments					*/
	/*     - too many arguments					*/
	/* ###------------------------------------------------------### */

  if ((argc > 11) || (argc < 3))
    arg_err = 1;

  for (i=0 ; i<argc ; i++)
    {
    if (arg_flg [i] == 0)
      arg_err = 1;
    }

  if (arg_err == 1)
    {
    mips_error (101, NULL);
    exit (1);
    }

	/* ###------------------------------------------------------### */
	/*   open source file (assembly) and result files (vhdl)	*/
	/* ###------------------------------------------------------### */

  if ((fp_read = fopen (argv [asm_fil], "r")) == NULL)
    {
    mips_error (100, argv [asm_fil]);
    exit (1);
    }

  if (MPS_DUMP != 'y')
    {
    if ((MPS_TXTFIL = mbkfopen (argv[txt_fil], "vbe", WRITE_TEXT)) == NULL)
      {
      mips_error (100, argv [txt_fil]);
      exit (1);
      }

    if (dat_fil != 0)
      {
      if ((MPS_DATFIL = mbkfopen (argv[dat_fil], "vbe", WRITE_TEXT)) == NULL)
        {
        mips_error (100, argv [dat_fil]);
        exit (1);
        }
      }
    }
  else
    {
    if ((MPS_TXTFIL = fopen (argv[txt_fil], "w")) == NULL)
      {
      mips_error (100, argv [txt_fil]);
      exit (1);
      }
    if (dat_fil != 0)
      {
      if ((MPS_DATFIL = fopen (argv[txt_fil], "w")) == NULL)
        {
        mips_error (100, argv [dat_fil]);
        exit (1);
        }
      }
    }

  if (MPS_SYMBOL == 'y')
    {
    if ((MPS_SYMFIL = fopen (symbol_fil, "w")) == NULL)
      {
      mips_error (100, symbol_fil);
      exit (1);
      }
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the text address.	*/
	/* The address is a word (4 bytes) address			*/
	/* ###------------------------------------------------------### */

  txt_siz = (txt_siz >> 2) - 1;
  while (txt_siz != 0)
    {
    txt_siz = txt_siz >> 1;
    MPS_TXTSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   compute the length (number of bits) of the data address	*/
	/* ###------------------------------------------------------### */

  dat_siz -= 1;
  while (dat_siz != 0)
    {
    dat_siz = dat_siz >> 1;
    MPS_DATSIZ ++;
    }

	/* ###------------------------------------------------------### */
	/*   call the assembly file parser (two passes):		*/
	/*	- set the address space (by default) to text		*/
	/*      - in the first pass identify labels			*/
	/*      - if no error has been found print the result files'	*/
	/*        header						*/
	/*      - translate insstructions in the second pass		*/
	/*      - print the result files' foot				*/
	/* ###------------------------------------------------------### */

  MPS_ADRSPC = 'T'       ;
  MPS_ADDRES = MPS_TXTADR;
  MPS_WRTFIL = MPS_TXTFIL;
  MPS_ADRSIZ = MPS_TXTSIZ;
  MPS_WRDSIZ = 4         ;

  MPS_PASNBR = 1  ;

  if (call_nbr != 0)
    yyrestart (yyin);

  yyin = fp_read;
  yyparse ();

  call_nbr++;

  if (MPS_ERRFLG == 0)
    {
    fclose (fp_read);
    fp_read = fopen (argv [asm_fil], "r");
    yyin    = fp_read;

    MPS_ADRSPC = 'T';
    MPS_ADDRES = MPS_TXTADR;
    MPS_WRTFIL = MPS_TXTFIL;
    MPS_ADRSIZ = MPS_TXTSIZ;
    MPS_WRDSIZ = 4;

    MPS_PASNBR = 2  ;
    MPS_LINNUM = 1  ;

    if (MPS_DUMP != 'y')
      {
      mips_head (MPS_TXTFIL, argv [txt_fil], MPS_TXTSIZ, 4);
      if (MPS_DATFIL != NULL)
        mips_head (MPS_DATFIL, argv [dat_fil], MPS_DATSIZ, 1);
      }

    yyrestart (yyin);
    yyparse ();

    if (MPS_DUMP != 'y')
      {
      mips_foot (MPS_TXTFIL, 4);
      if (MPS_DATFIL != NULL)
        mips_foot (MPS_DATFIL, 1);
      }

    exit_val = 0;

    }

	/* ###------------------------------------------------------### */
	/*   close source and result files				*/
	/* ###------------------------------------------------------### */

  fclose (fp_read);
  fclose (MPS_TXTFIL);

  if (MPS_DATFIL != NULL)
    fclose (MPS_DATFIL);

  if (MPS_SYMBOL == 'y')
    fclose (MPS_SYMFIL);

  exit (exit_val);
  }



/* Line 268 of yacc.c  */
#line 362 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     _ALIGN = 258,
     _ASCII = 259,
     _ASCIIZ = 260,
     _BYTE = 261,
     _BYTEZ = 262,
     _DATA = 263,
     _END = 264,
     _EQU = 265,
     _GLOBAL = 266,
     _ORG = 267,
     _SPACE = 268,
     _SKIP = 269,
     _START = 270,
     _TEXT = 271,
     _WORD = 272,
     Ampersand = 273,
     Bar = 274,
     CarriageReturn = 275,
     Circomflex = 276,
     Codop_rd = 277,
     Codop_rd_rs_rt = 278,
     Codop_rd_rt_sham = 279,
     Codop_rd_rt_rs = 280,
     Codop_rd_rs_imd = 281,
     Codop_rs_rt_labl = 282,
     Codop_od_rs = 283,
     Codop_rs = 284,
     Codop_rd_mem = 285,
     Codop_rt_mem = 286,
     Codop_rt_cp0rd = 287,
     Codop_rs_labl = 288,
     Codop_rd_imd = 289,
     Codop_labl = 290,
     Codop_imd = 291,
     Codop_n = 292,
     Colon = 293,
     Comma = 294,
     CP0Register = 295,
     DoubleGreat = 296,
     DoubleLess = 297,
     Identifier = 298,
     IntegerRegister = 299,
     LeftParen = 300,
     Litteral = 301,
     Macro_n = 302,
     Macro_rd_longi = 303,
     Minus = 304,
     Plus = 305,
     Register = 306,
     RightParen = 307,
     Sharp = 308,
     Slash = 309,
     Star = 310,
     String = 311,
     Tilda = 312
   };
#endif
/* Tokens.  */
#define _ALIGN 258
#define _ASCII 259
#define _ASCIIZ 260
#define _BYTE 261
#define _BYTEZ 262
#define _DATA 263
#define _END 264
#define _EQU 265
#define _GLOBAL 266
#define _ORG 267
#define _SPACE 268
#define _SKIP 269
#define _START 270
#define _TEXT 271
#define _WORD 272
#define Ampersand 273
#define Bar 274
#define CarriageReturn 275
#define Circomflex 276
#define Codop_rd 277
#define Codop_rd_rs_rt 278
#define Codop_rd_rt_sham 279
#define Codop_rd_rt_rs 280
#define Codop_rd_rs_imd 281
#define Codop_rs_rt_labl 282
#define Codop_od_rs 283
#define Codop_rs 284
#define Codop_rd_mem 285
#define Codop_rt_mem 286
#define Codop_rt_cp0rd 287
#define Codop_rs_labl 288
#define Codop_rd_imd 289
#define Codop_labl 290
#define Codop_imd 291
#define Codop_n 292
#define Colon 293
#define Comma 294
#define CP0Register 295
#define DoubleGreat 296
#define DoubleLess 297
#define Identifier 298
#define IntegerRegister 299
#define LeftParen 300
#define Litteral 301
#define Macro_n 302
#define Macro_rd_longi 303
#define Minus 304
#define Plus 305
#define Register 306
#define RightParen 307
#define Sharp 308
#define Slash 309
#define Star 310
#define String 311
#define Tilda 312




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 323 "./mips_y.y"

  unsigned long  valu;
  struct immd    immd;
  char          *text;
  


/* Line 293 of yacc.c  */
#line 520 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 532 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   251

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  58
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  67
/* YYNRULES -- Number of rules.  */
#define YYNRULES  130
/* YYNRULES -- Number of states.  */
#define YYNSTATES  222

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     8,     9,    12,    16,    19,    22,
      23,    26,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    45,    48,    51,    54,    57,    60,    62,    64,    66,
      68,    70,    72,    74,    77,    80,    83,    86,    87,    89,
      92,    95,    98,   101,   104,   108,   110,   112,   114,   116,
     118,   120,   122,   124,   126,   128,   130,   132,   134,   136,
     138,   140,   142,   144,   151,   158,   163,   166,   169,   174,
     177,   185,   193,   201,   209,   216,   221,   226,   230,   233,
     235,   236,   238,   240,   242,   247,   249,   251,   252,   254,
     256,   258,   260,   262,   264,   268,   272,   276,   280,   284,
     288,   290,   292,   294,   296,   300,   305,   310,   312,   314,
     316,   318,   320,   322,   324,   327,   330,   332,   335,   338,
     340,   342,   344,   346,   348,   350,   352,   354,   356,   357,
     360
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      59,     0,    -1,    60,    76,    -1,    61,    -1,    -1,    61,
      62,    -1,    63,    64,   124,    -1,    71,   124,    -1,     1,
     124,    -1,    -1,   122,    38,    -1,    -1,    65,    -1,    83,
      -1,    66,    -1,    67,    -1,    68,    -1,    69,    -1,    70,
      -1,    80,    -1,    79,    -1,    17,   107,    -1,     6,   107,
      -1,     7,   107,    -1,     4,    56,    -1,     5,    56,    -1,
      75,    -1,    72,    -1,    82,    -1,    74,    -1,    81,    -1,
      78,    -1,    73,    -1,     8,   106,    -1,    16,   106,    -1,
      11,   122,    -1,     3,    46,    -1,    -1,    77,    -1,     9,
     123,    -1,    15,   122,    -1,    13,    46,    -1,    14,    46,
      -1,    12,   107,    -1,    43,    10,   107,    -1,    84,    -1,
     102,    -1,   100,    -1,    99,    -1,    98,    -1,    97,    -1,
      96,    -1,    95,    -1,    93,    -1,    94,    -1,    91,    -1,
      92,    -1,    88,    -1,    89,    -1,    90,    -1,    85,    -1,
      86,    -1,    87,    -1,    23,   118,    39,   119,    39,   119,
      -1,    25,   118,    39,   119,    39,   119,    -1,    32,   120,
      39,   121,    -1,    22,   118,    -1,    28,   119,    -1,    28,
     118,    39,   119,    -1,    29,   119,    -1,    26,   118,    39,
     119,    39,   101,   107,    -1,    24,   118,    39,   119,    39,
     101,   107,    -1,    30,   118,    39,   105,    45,   119,    52,
      -1,    31,   119,    39,   105,    45,   119,    52,    -1,    27,
     119,    39,   119,    39,   107,    -1,    33,   119,    39,   107,
      -1,    34,   118,    39,   107,    -1,    36,   101,   107,    -1,
      35,   107,    -1,    37,    -1,    -1,    53,    -1,   103,    -1,
     104,    -1,    48,   118,    39,   107,    -1,    47,    -1,   107,
      -1,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   114,    -1,   108,   116,   114,    -1,   114,   113,
     114,    -1,   109,    55,   114,    -1,   114,   115,   114,    -1,
     110,   115,   114,    -1,   114,   112,   114,    -1,    42,    -1,
      41,    -1,    55,    -1,    54,    -1,    45,   107,    52,    -1,
      57,    45,   107,    52,    -1,    49,    45,   107,    52,    -1,
     117,    -1,    19,    -1,    18,    -1,    21,    -1,    50,    -1,
      49,    -1,    46,    -1,    49,    46,    -1,    57,    46,    -1,
      43,    -1,    49,    43,    -1,    57,    43,    -1,    44,    -1,
      51,    -1,    44,    -1,    51,    -1,    44,    -1,    51,    -1,
      40,    -1,    51,    -1,    43,    -1,    -1,   123,   124,    -1,
      20,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   440,   440,   445,   448,   450,   455,   458,   460,   464,
     466,   490,   492,   502,   515,   517,   519,   521,   523,   525,
     530,   538,   552,   567,   585,   598,   617,   618,   619,   620,
     621,   622,   623,   627,   659,   691,   696,   722,   724,   728,
     733,   738,   746,   754,   769,   799,   801,   806,   808,   810,
     812,   814,   816,   818,   820,   822,   824,   826,   828,   830,
     832,   834,   836,   841,   862,   883,   902,   919,   933,   952,
     969,   994,  1019,  1044,  1069,  1101,  1131,  1153,  1174,  1202,
    1217,  1219,  1223,  1225,  1230,  1268,  1289,  1295,  1299,  1304,
    1306,  1308,  1310,  1315,  1317,  1339,  1358,  1377,  1400,  1426,
    1448,  1450,  1455,  1457,  1462,  1468,  1476,  1484,  1489,  1491,
    1493,  1498,  1500,  1505,  1510,  1516,  1522,  1530,  1539,  1551,
    1553,  1558,  1560,  1565,  1567,  1572,  1574,  1579,  1583,  1585,
    1590
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "_ALIGN", "_ASCII", "_ASCIIZ", "_BYTE",
  "_BYTEZ", "_DATA", "_END", "_EQU", "_GLOBAL", "_ORG", "_SPACE", "_SKIP",
  "_START", "_TEXT", "_WORD", "Ampersand", "Bar", "CarriageReturn",
  "Circomflex", "Codop_rd", "Codop_rd_rs_rt", "Codop_rd_rt_sham",
  "Codop_rd_rt_rs", "Codop_rd_rs_imd", "Codop_rs_rt_labl", "Codop_od_rs",
  "Codop_rs", "Codop_rd_mem", "Codop_rt_mem", "Codop_rt_cp0rd",
  "Codop_rs_labl", "Codop_rd_imd", "Codop_labl", "Codop_imd", "Codop_n",
  "Colon", "Comma", "CP0Register", "DoubleGreat", "DoubleLess",
  "Identifier", "IntegerRegister", "LeftParen", "Litteral", "Macro_n",
  "Macro_rd_longi", "Minus", "Plus", "Register", "RightParen", "Sharp",
  "Slash", "Star", "String", "Tilda", "$accept", "mips_assembly_prog",
  "assembly_instructions", "..an_assembly_instruction..",
  "an_assembly_instruction", ".a_label.",
  ".unlabeled_assembly_instruction.", "mem_alloc_directive", "word_alloc",
  "byte_alloc", "bytez_alloc", "ascii_alloc", "asciiz_alloc",
  "unlabeled_pseudo_instruction", "data_pseudo_inst", "text_pseudo_inst",
  "global_pseudo_inst", "align_pseudo_inst", ".end_pseudo_inst.",
  "end_pseudo_inst", "start_pseudo_inst", "space_pseudo_inst",
  "skip_pseudo_inst", "org_pseudo_inst", "equ_pseudo_inst",
  "effective_instruction", "mips_instruction", "format_rd_rs_rt",
  "format_rd_rt_rs", "format_rt_cp0rd", "format_rd", "format_od_rs",
  "format_rs", "format_rd_rs_imd", "format_rd_rt_sham", "format_rd_mem",
  "format_rt_mem", "format_rs_rt_labl", "format_rs_labl", "format_rd_imd",
  "format_imd", "format_labl", "format_n", ".sharp.", "macro_instruction",
  "macro_ri", "macro_n", "offset", ".immediate.", "immediate",
  "expr..addop__expr..", "expr__mulop__expr..mulop__expr..",
  "expr__logop__expr..logop__expr..", "expr__shfop__expr",
  "shift_operator", "mul_div_operator", "expression", "logical_operator",
  "adding_operator", "term", "destination_register", "source_register",
  "integer_register", "cp0_reg", "label", "..CR..", "CarriageReturn_ERR", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    58,    59,    60,    61,    61,    62,    62,    62,    63,
      63,    64,    64,    64,    65,    65,    65,    65,    65,    65,
      65,    66,    67,    68,    69,    70,    71,    71,    71,    71,
      71,    71,    71,    72,    73,    74,    75,    76,    76,    77,
      78,    79,    80,    81,    82,    83,    83,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    85,    86,    87,    88,    89,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   101,   102,   102,   103,   104,   105,   106,   106,   107,
     107,   107,   107,   108,   108,   109,   109,   110,   110,   111,
     112,   112,   113,   113,   114,   114,   114,   114,   115,   115,
     115,   116,   116,   117,   117,   117,   117,   117,   117,   118,
     118,   119,   119,   120,   120,   121,   121,   122,   123,   123,
     124
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     0,     2,     3,     2,     2,     0,
       2,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     0,     1,     2,
       2,     2,     2,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     6,     4,     2,     2,     4,     2,
       7,     7,     7,     7,     6,     4,     4,     3,     2,     1,
       0,     1,     1,     1,     4,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,    37,     0,     1,   128,     2,    38,     0,     0,
      87,     0,     0,     0,    87,   127,     5,    11,     0,    27,
      32,    29,    26,    31,    30,    28,     0,    39,   130,     8,
      36,   116,     0,   113,     0,     0,    33,    88,    89,    90,
      91,    92,    93,   107,   127,    35,    43,    40,    34,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    80,    79,    85,     0,     0,    12,    14,    15,    16,
      17,    18,    20,    19,    13,    45,    60,    61,    62,    57,
      58,    59,    55,    56,    53,    54,    52,    51,    50,    49,
      48,    47,    46,    82,    83,     7,    10,   129,     0,   117,
       0,   114,   118,     0,   115,   112,   111,     0,     0,   109,
     108,   110,     0,   101,   100,   103,   102,     0,     0,     0,
      44,    24,    25,    22,    23,    41,    42,    21,   119,   120,
      66,     0,     0,     0,     0,   121,   122,     0,   119,   120,
       0,    67,    69,     0,     0,   123,   124,     0,     0,     0,
      78,    81,     0,     0,     6,   104,     0,     0,    94,    96,
      98,    99,    95,    97,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    77,     0,   106,   105,     0,
       0,     0,     0,     0,    68,     0,    86,     0,   125,   126,
      65,    75,    76,    84,     0,    80,     0,    80,     0,     0,
       0,    63,     0,    64,     0,    74,     0,     0,    71,    70,
      72,    73
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     3,    16,    17,    75,    76,    77,    78,
      79,    80,    81,    18,    19,    20,    21,    22,     6,     7,
      23,    82,    83,    24,    25,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   162,   102,   103,   104,   195,    36,    37,
      38,    39,    40,    41,   127,   128,    42,   122,   117,    43,
     140,   147,   157,   200,    26,    27,    29
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -145
static const yytype_int16 yypact[] =
{
    -145,     9,     5,   203,  -145,  -145,  -145,  -145,    16,    11,
     -38,   -18,   -38,   -18,   -38,    19,  -145,    42,    16,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,    12,    16,  -145,  -145,
    -145,  -145,   -38,  -145,    49,    54,  -145,  -145,     4,     7,
      24,  -145,    -3,  -145,  -145,  -145,  -145,  -145,  -145,   -38,
      32,    37,   -38,   -38,    56,    57,   -38,   -34,   -34,   -34,
     -34,   -34,   -21,   -17,   -21,   -34,   -21,   -16,   -21,   -34,
     -38,    51,  -145,  -145,   -34,    16,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,    53,  -145,
     -38,  -145,  -145,   -38,  -145,  -145,  -145,   -38,   -38,  -145,
    -145,  -145,   -38,  -145,  -145,  -145,  -145,   -38,   -38,   -38,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,    67,    68,    69,    70,  -145,  -145,    71,    91,    98,
      80,  -145,  -145,    81,    82,  -145,  -145,    83,    84,    85,
    -145,  -145,   -38,    86,  -145,  -145,    74,    75,  -145,  -145,
    -145,  -145,  -145,  -145,   -21,   -21,   -21,   -21,   -21,   -21,
     -38,   -38,   -27,   -38,   -38,  -145,   -38,  -145,  -145,    89,
      90,    92,    93,    94,  -145,    95,  -145,    96,  -145,  -145,
    -145,  -145,  -145,  -145,   -21,    51,   -21,    51,   -38,   -21,
     -21,  -145,   -38,  -145,   -38,  -145,    78,    87,  -145,  -145,
    -145,  -145
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,  -145,
    -145,  -145,  -145,  -144,  -145,  -145,  -145,   -47,   121,   -12,
    -145,  -145,  -145,  -145,  -145,  -145,   -96,   101,  -145,  -145,
      22,   -62,  -145,  -145,    73,  -145,   -15
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -123
static const yytype_int16 yytable[] =
{
      46,   151,   152,   105,   154,    31,   158,    32,    33,     4,
     138,    34,   107,   198,     5,   119,   120,   139,   121,    35,
     108,   168,   169,   145,   199,    44,   170,   148,   155,    49,
     146,   171,   172,   173,   149,   156,    28,   130,   123,   124,
     133,   134,   119,   120,   137,   121,    50,    51,    52,    53,
     106,   125,   126,   115,   116,    54,    55,    30,   160,    56,
     164,   212,   118,   214,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     141,   142,   143,   144,    45,   150,    47,   153,   131,    73,
      74,   159,   109,   132,   110,   111,   163,   112,   166,   113,
     114,   167,   135,   136,   161,   165,   174,   175,   176,   177,
     178,  -121,   189,   190,   191,   192,   193,   194,  -122,   179,
     180,   181,   182,   183,   184,   186,   187,   188,   204,   205,
     220,   206,   207,   208,   197,    48,     0,     0,     0,   221,
     209,   210,   211,   129,   213,     0,     0,   216,   217,     0,
     185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   196,   196,
       0,   201,   202,     0,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   215,     0,     0,     0,
     218,     0,   219,    -3,     8,     0,     9,    -9,    -9,    -9,
      -9,    10,    -3,     0,    11,    12,    -9,    -9,    13,    14,
      -9,     0,     0,    -9,     0,    -9,    -9,    -9,    -9,    -9,
      -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,    -9,
      -9,     0,     0,     0,     0,     0,    15,     0,     0,     0,
      -9,    -9
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-145))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      12,    63,    64,    18,    66,    43,    68,    45,    46,     0,
      44,    49,    27,    40,     9,    18,    19,    51,    21,    57,
      32,   117,   118,    44,    51,    43,   122,    44,    44,    10,
      51,   127,   128,   129,    51,    51,    20,    49,    41,    42,
      52,    53,    18,    19,    56,    21,     4,     5,     6,     7,
      38,    54,    55,    49,    50,    13,    14,    46,    70,    17,
      75,   205,    55,   207,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      58,    59,    60,    61,    11,    63,    13,    65,    56,    47,
      48,    69,    43,    56,    45,    46,    74,    43,   110,    45,
      46,   113,    46,    46,    53,    52,    39,    39,    39,    39,
      39,    20,   174,   175,   176,   177,   178,   179,    20,    39,
      39,    39,    39,    39,    39,    39,    52,    52,    39,    39,
      52,    39,    39,    39,   181,    14,    -1,    -1,    -1,    52,
      45,    45,   204,    42,   206,    -1,    -1,   209,   210,    -1,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,   181,
      -1,   183,   184,    -1,   186,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,
     212,    -1,   214,     0,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,
      47,    48
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    59,    60,    61,     0,     9,    76,    77,     1,     3,
       8,    11,    12,    15,    16,    43,    62,    63,    71,    72,
      73,    74,    75,    78,    81,    82,   122,   123,    20,   124,
      46,    43,    45,    46,    49,    57,   106,   107,   108,   109,
     110,   111,   114,   117,    43,   122,   107,   122,   106,    10,
       4,     5,     6,     7,    13,    14,    17,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    47,    48,    64,    65,    66,    67,    68,
      69,    70,    79,    80,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   102,   103,   104,   124,    38,   124,   107,    43,
      45,    46,    43,    45,    46,    49,    50,   116,    55,    18,
      19,    21,   115,    41,    42,    54,    55,   112,   113,   115,
     107,    56,    56,   107,   107,    46,    46,   107,    44,    51,
     118,   118,   118,   118,   118,    44,    51,   119,    44,    51,
     118,   119,   119,   118,   119,    44,    51,   120,   119,   118,
     107,    53,   101,   118,   124,    52,   107,   107,   114,   114,
     114,   114,   114,   114,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,   107,    39,    52,    52,   119,
     119,   119,   119,   119,   119,   105,   107,   105,    40,    51,
     121,   107,   107,   107,    39,    39,    39,    39,    39,    45,
      45,   119,   101,   119,   101,   107,   119,   119,   107,   107,
      52,    52
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 10:

/* Line 1806 of yacc.c  */
#line 468 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the label is unique.	*/
		/* Save its address in the dictionary and flag it as a	*/
		/* label.						*/
		/* ###----------------------------------------------### */

		if (MPS_PASNBR == 1)
		  {
		  if (beh_chktab (MPS_HSHTAB, (yyvsp[(1) - (2)].text), NULL, 0) == 0)
		    {
		    beh_addtab (MPS_HSHTAB, (yyvsp[(1) - (2)].text), NULL, 0, 'l'       );
		    beh_addtab (MPS_HSHTAB, (yyvsp[(1) - (2)].text), NULL, 7, MPS_ADDRES);
		    if (MPS_SYMBOL == 'y')
		      mips_symbol ((yyvsp[(1) - (2)].text));
		    }
		  else
		    mips_error (3, NULL);
		  }
		}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 493 "./mips_y.y"
    {
		if ((MPS_PASNBR == 2) && ((yyvsp[(1) - (1)].immd).flag == 0))
		  mips_error (4, NULL);

		if (MPS_PASNBR == 2)
		  mips_print ((yyvsp[(1) - (1)].immd).valu);

		MPS_ADDRES += (yyvsp[(1) - (1)].immd).valu;
		}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 503 "./mips_y.y"
    {
		if ((MPS_PASNBR == 2) && ((yyvsp[(1) - (1)].immd).flag == 0))
		  mips_error (4, NULL);

		if (MPS_PASNBR == 2)
		  mips_print ((yyvsp[(1) - (1)].immd).valu);

		MPS_ADDRES += (yyvsp[(1) - (1)].immd).valu;
		}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 516 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 518 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 520 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 522 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 524 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 526 "./mips_y.y"
    {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 531 "./mips_y.y"
    {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 540 "./mips_y.y"
    {
		MPS_BYTTAB [3] = (yyvsp[(2) - (2)].immd).valu >> 24;
		MPS_BYTTAB [2] = (yyvsp[(2) - (2)].immd).valu >> 16;
		MPS_BYTTAB [1] = (yyvsp[(2) - (2)].immd).valu >>  8;
		MPS_BYTTAB [0] = (yyvsp[(2) - (2)].immd).valu      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(2) - (2)].immd).flag;
		}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 554 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   initialize a byte address with a value		*/
		/* ###----------------------------------------------### */

		MPS_BYTTAB [0] = (yyvsp[(2) - (2)].immd).valu;

		(yyval.immd).valu = 1      ;
		(yyval.immd).flag = (yyvsp[(2) - (2)].immd).flag;
		}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 569 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   initialize a byte table with zeros			*/
		/* ###----------------------------------------------### */

		unsigned int i;

		for (i=0; i<(yyvsp[(2) - (2)].immd).valu ; i++)
		  MPS_BYTTAB [i] = 0x00;

		(yyval.immd).valu = (yyvsp[(2) - (2)].immd).valu;
		(yyval.immd).flag = (yyvsp[(2) - (2)].immd).flag;
		}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 587 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* ###----------------------------------------------### */

		(yyval.immd).valu = mips_strtobin ((yyvsp[(2) - (2)].text), MPS_BYTTAB);
		(yyval.immd).flag = 'n';
		}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 600 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   initialize a set of addresses with a string	*/
		/* followed by a null character				*/
		/* ###----------------------------------------------### */

		unsigned int size;

		size = mips_strtobin ((yyvsp[(2) - (2)].text), MPS_BYTTAB);
		MPS_BYTTAB [size] = '\0';

		(yyval.immd).valu = size + 1;
		(yyval.immd).flag = 'n';
		}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 629 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   if the current region is the 'text region', switch	*/
		/* to the 'data region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (MPS_ADRSPC == 'T')
		  {
		  MPS_TXTADR = MPS_ADDRES;

		  MPS_ADDRES = MPS_DATADR;
		  MPS_WRTFIL = MPS_DATFIL;
		  MPS_ADRSIZ = MPS_DATSIZ;
		  MPS_WRDSIZ =  1 ;
		  MPS_ADRSPC = 'D';
		  }

		if ((yyvsp[(2) - (2)].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[(2) - (2)].immd).valu;
		else
		  {
		  if ((yyvsp[(2) - (2)].immd).flag != 'n')
		    mips_error (4, NULL);
		  }
		}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 661 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   if the current region is the 'data region', switch	*/
		/* to the 'text region'.				*/
		/*   if an address is defined, set the current data	*/
		/* address.						*/
		/* ###----------------------------------------------### */

		if (MPS_ADRSPC == 'D')
		  {
		  MPS_DATADR = MPS_ADDRES;

		  MPS_ADDRES = MPS_TXTADR;
		  MPS_WRTFIL = MPS_TXTFIL;
		  MPS_ADRSIZ = MPS_TXTSIZ;
		  MPS_WRDSIZ = 4;
		  MPS_ADRSPC = 'T';
		  }

		if ((yyvsp[(2) - (2)].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[(2) - (2)].immd).valu;
		else
		  {
		  if ((yyvsp[(2) - (2)].immd).flag != 'n')
		    mips_error (4, NULL);
		  }
		}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 698 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   align the current address				*/
		/* ###----------------------------------------------### */

		switch ((yyvsp[(2) - (2)].valu))
		  {
		  case 1:
		    break;
		  case 2:
		    MPS_ADDRES = (MPS_ADDRES + 1) & 0xfffffffe;
		    break;
		  case 4:
		    MPS_ADDRES = (MPS_ADDRES + 3) & 0xfffffffc;
		    break;
		  case 8:
		    MPS_ADDRES = (MPS_ADDRES + 7) & 0xfffffff8;
		    break;
		  default:
		    mips_error (4, NULL);
		  }
		}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 740 "./mips_y.y"
    {
		MPS_ADDRES += (yyvsp[(2) - (2)].valu);
		}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 748 "./mips_y.y"
    {
		MPS_ADDRES += (yyvsp[(2) - (2)].valu);
		}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 756 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   define the first address (must be an immediate)	*/
		/* ###----------------------------------------------### */

		if ((yyvsp[(2) - (2)].immd).flag == 'i')
		  MPS_ADDRES = (yyvsp[(2) - (2)].immd).valu;
		else
		  mips_error (4, NULL);
		}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 772 "./mips_y.y"
    {
		/* ###----------------------------------------------### */
		/*   in the first pass, check that the identifier has	*/
		/* not been defined ealier.				*/
		/*   Save its value in the dictionary and flag it as	*/
		/* an immediate.					*/
		/* ###----------------------------------------------### */

		if (MPS_PASNBR == 1)
		  {
		  if ((yyvsp[(3) - (3)].immd).flag == 'i')
		    {
		    if (beh_chktab (MPS_HSHTAB, (yyvsp[(1) - (3)].text), NULL, 0) == 0)
		      {
		      beh_addtab (MPS_HSHTAB, (yyvsp[(1) - (3)].text), NULL, 0, 'i'    );
		      beh_addtab (MPS_HSHTAB, (yyvsp[(1) - (3)].text), NULL, 7, (yyvsp[(3) - (3)].immd).valu);
		      }
		    else
		      mips_error (3, NULL);
		    }
		  else
		    mips_error (4, NULL);
		  }
		}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 800 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 802 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 807 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 809 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 811 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 813 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 815 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 817 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 819 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 821 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 823 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 825 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 827 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 829 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 831 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 833 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 835 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 837 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 847 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (6)].valu) | ((yyvsp[(4) - (6)].valu) << 21) | ((yyvsp[(6) - (6)].valu) << 16) | ((yyvsp[(2) - (6)].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 868 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (6)].valu) | ((yyvsp[(6) - (6)].valu) << 21) | ((yyvsp[(4) - (6)].valu) << 16) | ((yyvsp[(2) - (6)].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4  ;
		(yyval.immd).flag = 'n';
		}
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 887 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (4)].valu) | ((yyvsp[(2) - (4)].valu) << 16) | ((yyvsp[(4) - (4)].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4  ;
		(yyval.immd).flag = 'n';
		}
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 904 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (2)].valu) | ((yyvsp[(2) - (2)].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 921 "./mips_y.y"
    {
		unsigned long inst = 0x0000f800;

		inst           |= (yyvsp[(1) - (2)].valu) | ((yyvsp[(2) - (2)].valu) << 21);
		MPS_BYTTAB [3]  = inst >> 24;
		MPS_BYTTAB [2]  = inst >> 16;
		MPS_BYTTAB [1]  = inst >>  8;
		MPS_BYTTAB [0]  = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 937 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (4)].valu) | ((yyvsp[(4) - (4)].valu) << 21) | ((yyvsp[(2) - (4)].valu) << 11);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 954 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (2)].valu) | ((yyvsp[(2) - (2)].valu) << 21);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 976 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[(7) - (7)].immd).valu;
		inst = (yyvsp[(1) - (7)].valu) | ((yyvsp[(4) - (7)].valu) << 21) | ((yyvsp[(2) - (7)].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(7) - (7)].immd).flag;
		}
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 1001 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000001f & (yyvsp[(7) - (7)].immd).valu;
		inst = (yyvsp[(1) - (7)].valu) | ((yyvsp[(4) - (7)].valu) << 16) | ((yyvsp[(2) - (7)].valu) << 11) | (imd << 6);

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(7) - (7)].immd).flag;
		}
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 1026 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[(4) - (7)].immd).valu;
		inst = (yyvsp[(1) - (7)].valu) | ((yyvsp[(6) - (7)].valu) << 21) | ((yyvsp[(2) - (7)].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(4) - (7)].immd).flag;
		}
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 1051 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[(4) - (7)].immd).valu;
		inst = (yyvsp[(1) - (7)].valu) | ((yyvsp[(6) - (7)].valu) << 21) | ((yyvsp[(2) - (7)].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(4) - (7)].immd).flag;
		}
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 1075 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if ((yyvsp[(6) - (6)].immd).flag == 'l')
		  imd = (yyvsp[(6) - (6)].immd).valu - MPS_ADDRES - 4;
		else
		  {
		  if (MPS_PASNBR == 2)
		    mips_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = (yyvsp[(1) - (6)].valu) | ((yyvsp[(2) - (6)].valu) << 21) | ((yyvsp[(4) - (6)].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4      ;
		(yyval.immd).flag = (yyvsp[(6) - (6)].immd).flag;
		}
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 1105 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		if ((yyvsp[(4) - (4)].immd).flag == 'l')
		  imd = (yyvsp[(4) - (4)].immd).valu - MPS_ADDRES - 4;
		else
		  {
		  if (MPS_PASNBR == 2)
		    mips_error (4, NULL);
		  }

		imd  = 0x0000ffff & (imd >> 2);
		inst = (yyvsp[(1) - (4)].valu) | ((yyvsp[(2) - (4)].valu) << 21) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(4) - (4)].immd).flag;
		}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 1135 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[(4) - (4)].immd).valu;
		inst = (yyvsp[(1) - (4)].valu) | ((yyvsp[(2) - (4)].valu) << 16) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(4) - (4)].immd).flag;
		}
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 1156 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd  = 0x0000ffff & (yyvsp[(3) - (3)].immd).valu;
		inst = (yyvsp[(1) - (3)].valu) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(3) - (3)].immd).flag;
		}
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 1176 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		imd = (yyvsp[(2) - (2)].immd).valu;
/*--------
		if ($2.flag == 'l')
		  imd = $2.valu - MPS_ADDRES - 4;
		else
		  imd = $2.valu;
----------*/

		imd  = 0x03ffffff & (imd >> 2);
		inst = (yyvsp[(1) - (2)].valu) | imd;

		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = (yyvsp[(2) - (2)].immd).flag;
		}
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 1203 "./mips_y.y"
    {
		unsigned long inst = 0;

		inst           = (yyvsp[(1) - (1)].valu);
		MPS_BYTTAB [3] = inst >> 24;
		MPS_BYTTAB [2] = inst >> 16;
		MPS_BYTTAB [1] = inst >>  8;
		MPS_BYTTAB [0] = inst      ;

		(yyval.immd).valu = 4;
		(yyval.immd).flag = 'n';
		}
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 1224 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 1226 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 1234 "./mips_y.y"
    {
		unsigned long imd  = 0;
		unsigned long inst = 0;

		switch ((yyvsp[(1) - (4)].valu))
		  {
		  case _LOADI :
		    imd  = 0x0000ffff & ((yyvsp[(4) - (4)].immd).valu >> 16);
		    inst = _LUI | ((yyvsp[(2) - (4)].valu) << 16) | imd;

		    MPS_BYTTAB [3] = inst >> 24;
		    MPS_BYTTAB [2] = inst >> 16;
		    MPS_BYTTAB [1] = inst >>  8;
		    MPS_BYTTAB [0] = inst      ;

		    imd  = 0x0000ffff & (yyvsp[(4) - (4)].immd).valu;
		    inst = _ORI | ((yyvsp[(2) - (4)].valu) << 21) | ((yyvsp[(2) - (4)].valu) << 16) | imd;

		    MPS_BYTTAB [7] = inst >> 24;
		    MPS_BYTTAB [6] = inst >> 16;
		    MPS_BYTTAB [5] = inst >>  8;
		    MPS_BYTTAB [4] = inst      ;

		    (yyval.immd).valu = 8;
		    (yyval.immd).flag = (yyvsp[(4) - (4)].immd).flag;
		    break;

		  default:
		    mips_error (5, NULL);
		  }
		}
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 1269 "./mips_y.y"
    {
		switch ((yyvsp[(1) - (1)].valu))
		  {
		  case _NOP :
		    MPS_BYTTAB [3] = 0x00;
		    MPS_BYTTAB [2] = 0x00;
		    MPS_BYTTAB [1] = 0x00;
		    MPS_BYTTAB [0] = 0x21;

		    (yyval.immd).valu = 4;
		    (yyval.immd).flag = 'n';
		    break;

		  default:
		    mips_error (5, NULL);
		  }
		}
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 1290 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 1295 "./mips_y.y"
    {
		(yyval.immd).valu = 0  ;
		(yyval.immd).flag = 'n';
		}
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 1300 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 1305 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 1307 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 1309 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 1311 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 1316 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 1320 "./mips_y.y"
    {
		if ((yyvsp[(2) - (3)].valu) == MPS_PLSDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu + (yyvsp[(3) - (3)].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu - (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 1342 "./mips_y.y"
    {
		if ((yyvsp[(2) - (3)].valu) == MPS_MULDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu * (yyvsp[(3) - (3)].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu / (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 1361 "./mips_y.y"
    {
		(yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu * (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 1380 "./mips_y.y"
    {
		if ((yyvsp[(2) - (3)].valu) == MPS_ORDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu | (yyvsp[(3) - (3)].immd).valu;

		if ((yyvsp[(2) - (3)].valu) == MPS_ANDDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu & (yyvsp[(3) - (3)].immd).valu;

		if ((yyvsp[(2) - (3)].valu) == MPS_XORDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu ^ (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 1403 "./mips_y.y"
    {
		if ((yyvsp[(2) - (3)].valu) == MPS_ORDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu | (yyvsp[(3) - (3)].immd).valu;

		if ((yyvsp[(2) - (3)].valu) == MPS_ANDDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu & (yyvsp[(3) - (3)].immd).valu;

		if ((yyvsp[(2) - (3)].valu) == MPS_XORDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu ^ (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 1429 "./mips_y.y"
    {
		if ((yyvsp[(2) - (3)].valu) == MPS_SHLDFN)
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu << (yyvsp[(3) - (3)].immd).valu;
		else
		  (yyval.immd).valu = (yyvsp[(1) - (3)].immd).valu >> (yyvsp[(3) - (3)].immd).valu;

		if (((yyvsp[(1) - (3)].immd).flag == 0) || ((yyvsp[(3) - (3)].immd).flag == 0))
		  (yyval.immd).flag = 0;
		else
		  {
		  if (((yyvsp[(1) - (3)].immd).flag == 'l') || ((yyvsp[(3) - (3)].immd).flag == 'l'))
		    (yyval.immd).flag = 'l';
		  else
		    (yyval.immd).flag = 'i';
		  }
		}
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 1449 "./mips_y.y"
    { (yyval.valu) = MPS_SHLDFN; }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 1451 "./mips_y.y"
    { (yyval.valu) = MPS_SHRDFN; }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 1456 "./mips_y.y"
    { (yyval.valu) = MPS_MULDFN; }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 1458 "./mips_y.y"
    { (yyval.valu) = MPS_DIVDFN; }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 1465 "./mips_y.y"
    {
		(yyval.immd) = (yyvsp[(2) - (3)].immd);
		}
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 1472 "./mips_y.y"
    {
		(yyval.immd).valu = ~ ((yyvsp[(3) - (4)].immd).valu);
		(yyval.immd).flag = (yyvsp[(3) - (4)].immd).flag;
		}
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 1480 "./mips_y.y"
    {
		(yyval.immd).valu = - (yyvsp[(3) - (4)].immd).valu;
		(yyval.immd).flag = (yyvsp[(3) - (4)].immd).flag;
		}
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 1485 "./mips_y.y"
    { (yyval.immd) = (yyvsp[(1) - (1)].immd); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 1490 "./mips_y.y"
    { (yyval.valu) = MPS_ORDFN;  }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 1492 "./mips_y.y"
    { (yyval.valu) = MPS_ANDDFN; }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 1494 "./mips_y.y"
    { (yyval.valu) = MPS_XORDFN; }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 1499 "./mips_y.y"
    { (yyval.valu) = MPS_PLSDFN; }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 1501 "./mips_y.y"
    { (yyval.valu) = MPS_MNSDFN; }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 1506 "./mips_y.y"
    {
		(yyval.immd).valu = (yyvsp[(1) - (1)].valu);
		(yyval.immd).flag = 'i';
		}
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 1512 "./mips_y.y"
    {
		(yyval.immd).valu = - (yyvsp[(2) - (2)].valu);
		(yyval.immd).flag = 'i';
		}
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 1518 "./mips_y.y"
    {
		(yyval.immd).valu = ~ (yyvsp[(2) - (2)].valu);
		(yyval.immd).flag = 'i';
		}
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 1523 "./mips_y.y"
    {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[(1) - (1)].text), NULL, 7);
		(yyval.immd).valu = imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[(1) - (1)].text), NULL, 0);
		}
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 1532 "./mips_y.y"
    {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[(2) - (2)].text), NULL, 7);
		(yyval.immd).valu = -imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[(2) - (2)].text), NULL, 0);
		}
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 1541 "./mips_y.y"
    {
		unsigned long imd;

		imd     = beh_chktab (MPS_HSHTAB, (yyvsp[(2) - (2)].text), NULL, 7);
		(yyval.immd).valu = ~imd;
		(yyval.immd).flag = beh_chktab (MPS_HSHTAB, (yyvsp[(2) - (2)].text), NULL, 0);
		}
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 1552 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 1554 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 1559 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 1561 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 1566 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 1568 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 1573 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 1575 "./mips_y.y"
    { (yyval.valu) = (yyvsp[(1) - (1)].valu); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 1580 "./mips_y.y"
    { (yyval.text) = (yyvsp[(1) - (1)].text); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 1591 "./mips_y.y"
    { yyerrok; }
    break;



/* Line 1806 of yacc.c  */
#line 3340 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1593 "./mips_y.y"


/* ###--------------------------------------------------------------### */
/* function	: mips_error						*/
/* description	: print an error message				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_error (code, str)

int   code;
char *str;

  {
  MPS_ERRFLG = 1;
  if (code <100)
    fprintf (stderr,"Error %d near line %d : ",code, MPS_LINNUM);

  switch (code)
    {
    case 2:
      fprintf (stderr, "missing label\n");
      break;
    case 3:
      fprintf (stderr, "redefinition of label\n");
      break;
    case 4:
      fprintf (stderr, "undifined string\n");
      break;
    case 5:
      fprintf (stderr, "parse error\n");
      break;
    case 6:
      fprintf (stderr, "no output file has been specified\n");
      break;
    case 100:
      fprintf (stderr, "cannot open file `%s`\n",str);
      break;
    case 101:
      fprintf (stderr, "usage: mips_asm [<options>] <assembly_file> <vhdl_file> <vhdl_file>\n");
      break;
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: yyerror						*/
/* description	: print yacc error messages				*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

yyerror (str)

char *str;

  {
  MPS_ERRFLG = 1;
  fprintf (stderr, "line %d : %s\n",MPS_LINNUM, str);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_foot						*/
/* description	: print the head lines of the behavioural description	*/
/*		  of a ROM. The 'address size' defines the number of	*/
/*		  bits of the address, the 'word size' defines the size	*/
/*		  of the rom line in bytes and the 'name' specifies the	*/
/*		  name of the Entity.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_head (fp, name, adr_siz, wrd_siz)

FILE         *fp;
char         *name;
unsigned int  adr_siz;
unsigned int  wrd_siz;

  {
  adr_siz --;
  wrd_siz = (wrd_siz * 8) - 1;

  fprintf (fp, "entity %s is\n  port (\n", name);
  fprintf (fp, "    address : in  bit_vector (%u downto 0);\n", adr_siz);
  fprintf (fp, "    e_n     : in  bit;\n");
  fprintf (fp, "    data    : out mux_vector (%u downto 0) bus;\n", wrd_siz);
  fprintf (fp, "    vdd     : in bit;\n");
  fprintf (fp, "    vss     : in bit);\nend %s;\n\n",name);
  fprintf (fp, "architecture VBE of %s is\n\n", name);
  fprintf (fp, "  signal rom_out : bit_vector (%u downto 0);\n\n", wrd_siz);
  fprintf (fp, "begin\n\n");
  fprintf (fp, "  write_out : block (e_n = '0')\n  begin\n");
  fprintf (fp, "    data <= guarded rom_out;\n  end block;\n\n");
  fprintf (fp, "  with address (%u downto 0) select\n  rom_out <=\n", adr_siz);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_foot						*/
/* description	: print the foot lines of the behavioural description	*/
/*		  of a ROM. The 'word size' defines the size of the	*/
/*		  rom line in bytes.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_foot (fp, wrd_siz)

FILE         *fp     ;
unsigned int  wrd_siz;

  {
  unsigned int i;

  fprintf (fp, "          X\"");

  for (i=0 ; i<wrd_siz ; i++)
    fprintf (fp, "00");

  fprintf (fp, "\" when others;\n\nend;\n");
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_print						*/
/* description	: print one or several lines of the rom content. the	*/
/*		  global variable 'word size' defines the size of the	*/
/*		  rom line in bytes.					*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_print (byte_nbr)

int byte_nbr;

  {
  unsigned int  i    ;
  unsigned int  j    ;
  unsigned long adr  ;
  unsigned long mask ;
  char          binadr [36];

  if (MPS_WRTFIL == NULL)
    {
    mips_error (6, NULL);
    exit (1);
    }
  else
    {
    if (byte_nbr != 0)
      {
      if (MPS_DUMP == 'y')
        {
        adr = MPS_ADDRES;
        for (i=0 ; i<byte_nbr ; i++)
          fprintf (MPS_WRTFIL, "%.8x : %.2x\n", adr+i, MPS_BYTTAB [i]);
        }
      else
        {
        if (MPS_WRDSIZ == 4)
          adr = MPS_ADDRES >> 2;
        else
          adr = MPS_ADDRES;

        for (i=0 ; i<byte_nbr ; i += MPS_WRDSIZ)
          {
          fprintf (MPS_WRTFIL, "          X\"");

          for (j=0 ; j<MPS_WRDSIZ ; j++)
            fprintf (MPS_WRTFIL, "%.2x", MPS_BYTTAB [i+MPS_WRDSIZ-j-1]);

          mask = 0x00000001 << (MPS_ADRSIZ - 1);
          for (j=0 ; j<MPS_ADRSIZ ; j++)
            {
            if ((adr & mask) != 0)
              binadr [j] = '1';
            else
              binadr [j] = '0';
            mask = mask >> 1;
            }
          binadr [j] = '\0';

          fprintf (MPS_WRTFIL, "\" when B\"%s\",\n", binadr);
          adr++;
          }
        }
      }
    }
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_symbol						*/
/* description	: print out the location (in text or data region) of a	*/
/*		  symbol						*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static void mips_symbol (str)

char *str;
  {
  char *seg;

  if (MPS_ADRSPC == 'T')
    seg = "text";
  else
    seg = "data";

  fprintf (MPS_SYMFIL, "%s\t: location %x in %s segment\n", str,
           MPS_ADDRES, seg);
  }

/* ###--------------------------------------------------------------### */
/* function	: mips_strtobin						*/
/* description	: make a binary  ? from a string			*/
/* called func.	: none							*/
/* ###--------------------------------------------------------------### */

static int mips_strtobin (str, tab)

char *str;
char *tab;

  {
  int  i  = 1;
  int  j  = 0;

  while (str [i] != '\0')
    {
    tab [j] = str [i];
    i++;
    if (str[i-1] == '\\')
      {
      if ((str [i] <= '7') && (str [i] >= '0'))
        {
        tab [j] = str [i] - '0';
        i++;
        if ((str [i] <= '7') && (str [i] >= '0'))
          {
          tab [j] = (tab [j] * 8) + (str [i] - '0');
          i++;
          if ((str [i] <= '7') && (str [i] >= '0'))
            tab [j] = (tab [j] * 8) + (str [i] - '0');
          }
        }
      else
        {
        if (str [i] == '"')
          {
          tab [j] = str [i];
          i++;
          }
        }
      }

    j++;
    }

  return (j-1);
  }

